diff -u arc2/news.arc arc3/news.arc
--- arc2/news.arc	2008-02-24 20:39:48.000000000 -0500
+++ arc3/news.arc	2009-05-30 17:09:15.000000000 -0400
@@ -814,31 +1003,63 @@
 
 (= follow-threshold* 5)
 
-(def titlelink (s url user)
+(def titleline (s url user whence)
   (tag (td class 'title)
     (if (cansee user s)
-        (do (let toself (blank url)
-              (tag (a href (if toself (item-url s) url)
-                      rel  (unless (or toself 
-                                       (> (realscore s) follow-threshold*))
-                             'nofollow)) 
-                (pr (s 'title))))
-            (deadmark s user)
-            (awhen (and (valid-url url) (sitename url))
+        (do (deadmark s user)
+            (titlelink s url user)
+            (pdflink url)
+            (awhen (sitename url)
               (spanclass comhead
-                (pr " (" it ") "))))
+                (pr " (" )
+                (if (admin user)
+                    (w/rlink (do (set-site-ban user
+                                               it
+                                               (case (car (banned-sites* it))
+                                                 nil    'ignore
+                                                 ignore 'kill
+                                                 kill   nil))
+                                 whence)
+                      (let ban (car (banned-sites* it))
+                        (tag-if ban (font color (case ban 
+                                                  ignore darkred 
+                                                  kill   darkblue))
+                          (pr it))))
+                    (pr it))
+                (pr ") "))))
         (pr (pseudo-text s)))))
 
+(def titlelink (s url user)
+  (let toself (blank url)
+    (tag (a href (if toself 
+                      (item-url s!id) 
+                     (or (live s) (author user s) (editor user))
+                      url
+                      nil)
+            rel  (unless (or toself (> (realscore s) follow-threshold*))
+                   'nofollow)) 
+      (pr s!title))))
+
+(def pdflink (url)
+  (awhen (vacuumize url)
+    (pr " [") 
+    (link "scribd" it)
+    (pr "]")))
+
+(defmemo vacuumize (url)
+  (and (or (endmatch ".pdf" url) (endmatch ".PDF" url))
+       (+ "http://www.scribd.com/vacuum?url=" url)))
+      
 (def pseudo-text (i)
   (if i!deleted "[deleted]" "[dead]"))
 
 (def deadmark (i user)
   (when (and i!dead (seesdead user))
-    (pr " [dead]"))
+    (pr " [dead] "))
   (when (and i!deleted (admin user))
-    (pr " [deleted]")))
+    (pr " [deleted] ")))
 
-(= downvote-threshold* 20 downvote-time* 1440)
+(= downvote-threshold* 100 downvote-time* 1440)
 
 (= votewid* 14)
       
@@ -846,7 +1067,7 @@
   (center
     (if (and (cansee user i)
              (or (no user)
-                 (no ((votes* user) i!id))))
+                 (no ((votes user) i!id))))
          (do (votelink i user whence 'up)
              (if (and downtoo 
                       (or (admin user)
@@ -854,83 +1075,135 @@
                       (canvote user i 'down))
                  (do (br)
                      (votelink i user whence 'down))
+                 ; don't understand why needed, but is, or a new
+                 ; page is generated on voting
                  (tag (span id (string "down_" i!id)))))
-        (is user i!by)
-         (do (tag (font color orange) (pr "*"))
+        (author user i)
+         (do (fontcolor orange (pr "*"))
              (br)
              (hspace votewid*))
         (hspace votewid*))))
 
+; could memoize votelink more, esp for non-logged in users,
+; since only uparrow is shown; could straight memoize
+
+; redefined later (identically) so the outs catch new vals of up-url, etc.
+
 (def votelink (i user whence dir)
-  (tag (a id      (string dir '_ i!id)
+  (tag (a id      (if user (string dir '_ i!id))
           onclick (if user "return vote(this)")
-          href    (if user
-                      (string "vote?by=" user "&for=" i!id "&dir=" dir)
-                      (flink (vote-fn i whence dir))))
-    (gentag img src (case dir up up-url* down down-url*)
-                border 0 vspace 3 hspace 2)))
-
-(def vote-fn (i whence dir)
-  (fn (req)
-    (login-page 'both "You have to be logged in to vote."
-                (list (fn (u ip)
-                        (ensure-news-user u)
-                        (newslog u 'vote-login ip)
-                        (vote-for u i dir)
-                        (logvote u i))
-                      whence))))
+          href    (vote-url user i dir whence))
+    (if (is dir 'up)
+        (out (gentag img src up-url*   border 0 vspace 3 hspace 2))
+        (out (gentag img src down-url* border 0 vspace 3 hspace 2)))))
+
+(def vote-url (user i dir whence)
+  (+ "vote?" (if user (+ "by=" user "&")  "")
+             "for=" (coerce i!id 'string) 
+             "&dir=" (coerce dir 'string)
+             (if user (string "&auth=" (user->cookie* user)) "")
+             "&whence=" (urlencode whence)))
+
+(= lowest-score* -8)
 
 ; Not much stricter than whether to generate the arrow.  Further tests 
 ; applied in vote-for.
 
 (def canvote (user i dir)
   (and user
-       (no ((votes* user) i!id))
+       (news-type i)
+       (live i)
+       (or (is dir 'up) (> i!score lowest-score*))
+       (no ((votes user) i!id))
        (or (is dir 'up)
            (and (acomment i)
                 (> (karma user) downvote-threshold*)
-                (no (aand i!parent (is user ((item it) 'by))))))))
+                (no (aand i!parent (author user (item it))))))))
 
-; Can't use this for links when not logged in, because doesn't know
-; where to redirect after the login.  But that's few fnids anyway
-; because pages with those links are cached.  Now that have Javascript
-; voting, can use for all other votes because never have to regen
-; the page.
-
-(newsop vote (by for dir)
-  (let dir (saferead dir)
-    (if (isnt by user)
-        (pr "User mismatch.")
-        (aif (safe-item for)
-             (if (and (in dir 'up 'down) (canvote user it dir))
-                 (do (vote-for by it dir)
-                     (logvote by it))
-                 (pr "Can't make that vote."))
-             (pr "No such item.")))))
+; Need the by argument or someone could trick logged in users into 
+; voting something up by clicking on a link.  But a bad guy doesn't 
+; know how to generate an auth arg that matches each user's cookie.
+
+(newsop vote (by for dir auth whence)
+  (with (i      (safe-item for)
+         dir    (saferead dir)
+         whence (if whence (urldecode whence) "news"))
+    (if (no i)
+         (pr "No such item.")
+        (no (in dir 'up 'down))
+         (pr "Can't make that vote.")
+        (and by (or (isnt by user) (isnt (sym auth) (user->cookie* user))))
+         (pr "User mismatch.")
+        (no user)
+         (login-page 'both "You have to be logged in to vote."
+                     (list (fn (u ip)
+                             (ensure-news-user u)
+                             (newslog ip u 'vote-login)
+                             (when (canvote u i dir)
+                               (vote-for u i dir)
+                               (logvote ip u i)))
+                           whence))
+        (canvote user i dir)
+         (do (vote-for by i dir)
+             (logvote ip by i))
+         (pr "Can't make that vote."))))
 
 (def itemline (i user)
   (when (cansee user i) 
-    (when (news-type i)
-      (tag (span id (string "score_" i!id))
-        (pr i!score (plural i!score " point"))))
-    (byline i)))
+    (when (news-type i) (itemscore i user))
+    (byline i user)))
+
+(def itemscore (i (o user))
+  (tag (span id (string "score_" i!id))
+    (pr (plural (if (is i!type 'pollopt) (realscore i) i!score)
+                "point")))
+  (hook 'itemscore i user))
 
-(def byline (i)
+; redefined later
+
+(def byline (i user)
   (pr " by ")
-  (link i!by (user-url i!by))
+  (userlink user i!by)
   (pr " " (text-age:item-age i) " "))
 
 (def user-url (user) (+ "user?id=" user))
 
-(def commentlink (i user)
-  (when (cansee user i) (pr bar*))  ; smells like a hack
-  (tag (a href (item-url i))
-    (let n (- (len (visible user (family i))) 1)
-      (if (> n 0)
-          (pr n (plural n " comment"))
-          (pr "discuss")))))
+(= show-avg* nil)
 
-(def family (i) (cons i (mappend family:item i!kids)))
+(def userlink (user subject (o show-avg t))
+  (link (user-name user subject) (user-url subject))
+  (awhen (and show-avg* (admin user) show-avg (uvar subject avg))
+    (pr " (" (num it 1 t t) ")")))
+
+(= noob-color* (color 60 150 60))
+
+(def user-name (user subject)
+  (if (and (editor user) (ignored subject))
+       (tostring (fontcolor darkred (pr subject)))
+      (and (editor user) (< (user-age subject) 1440))
+       (tostring (fontcolor noob-color* (pr subject)))
+      subject))
+
+(= show-threadavg* nil)
+
+(def commentlink (i user)
+  (when (cansee user i) 
+    (pr bar*)
+    (tag (a href (item-url i!id))
+      (let n (- (visible-family user i) 1)
+        (if (> n 0)
+            (do (pr (plural n "comment"))
+                (awhen (and show-threadavg* (admin user) (threadavg i))
+                  (pr " (" (num it 1 t t) ")")))
+            (pr "discuss"))))))
+
+(def visible-family (user i)
+  (+ (if (cansee user i) 1 0)
+     (sum [visible-family user (item _)] i!kids)))
+
+(def threadavg (i)
+  (only.avg (map [or (uvar _ avg) 1] 
+                 (rem admin (dedup (map get!by (keep live (family i))))))))
 
 (= user-changetime* 120 editor-changetime* 1440)
 
@@ -944,18 +1217,91 @@
       (own-changeable-item user i)))
 
 (def own-changeable-item (user i)
-  (and (is user i!by)
+  (and (author user i)
+       (~mem 'locked i!keys)
        (no i!deleted)
        (or (everchange* i!type)
            (< (item-age i) user-changetime*))))
 
-(def editlink (story user)
-  (when (canedit user story)
+(def editlink (i user)
+  (when (canedit user i)
+    (pr bar*)
+    (link "edit" (edit-url i))))
+
+(def addoptlink (p user)
+  (when (or (admin user) (author user p))
     (pr bar*)
-    (link "edit" (edit-url story))))
+    (onlink "add choice" (add-pollopt-page p user))))
 
-(def candelete (user story)
-  (or (admin user) (own-changeable-item user story)))
+(= flag-threshold* 30 flag-kill-threshold* 7 many-flags* 1)
+
+; Un-flagging something doesn't unkill it, if it's now no longer
+; over flag-kill-threshold.  Ok, since arbitrary threshold anyway.
+
+(def flaglink (i user whence)
+  (when (and user 
+             (isnt user i!by)
+             (or (admin user) (> (karma user) flag-threshold*)))
+    (pr bar*)
+    (w/rlink (do (if (mem user i!flags)
+                     (pull user i!flags)
+                     (push user i!flags))
+                 (when (and (~mem 'nokill i!keys)
+                            (len> i!flags flag-kill-threshold*)
+                            (~find [admin _.2] i!vote))
+                   (kill i 'flags))
+                 whence)
+      (pr (if (mem user i!flags) "unflag" "flag")))
+    (when (and (admin user) (len> i!flags many-flags*))
+      (pr bar*)
+      (pr (plural (len i!flags) "flag") " ")
+      (w/rlink (do (if (mem 'nokill i!keys)
+                       (pull 'nokill i!keys)
+                       (push 'nokill i!keys))
+                   (save-item i)
+                   whence)
+        (pr (if (mem 'nokill i!keys) "un-notice" "noted"))))))
+
+(def killlink (i user whence)
+  (when (admin user)
+    (pr bar*)
+    (w/rlink (do (zap no i!dead)
+                 (if i!dead 
+                     (do (pull 'nokill i!keys)
+                         (log-kill i user))
+                     (pushnew 'nokill i!keys))
+                 (save-item i)
+                 whence)
+      (pr (if i!dead "unkill" "kill")))))
+
+; Blast kills the submission and bans the user.  Nuke also bans the 
+; site, so that all future submitters will be ignored.  Does not ban 
+; the ip address, but that will eventually get banned by maybe-ban-ip.
+
+(def blastlink (i user whence (o nuke))
+  (when (and (admin user) 
+             (or (no nuke) (~empty i!url)))
+    (pr bar*)
+    (w/rlink (do (toggle-blast i user nuke)
+                 whence)
+      (pr (if (ignored i!by) "un-" "")
+          (if nuke "nuke" "blast")))))
+
+(def toggle-blast (i user (o nuke))
+  (atomic
+    (if (ignored i!by)
+        (do (wipe i!dead (ignored i!by))
+            (awhen (and nuke (sitename i!url))
+              (set-site-ban user it nil)))
+        (do (set i!dead (ignored i!by))
+            (awhen (and nuke (sitename i!url))
+              (set-site-ban user it 'ignore))))
+    (if i!dead (log-kill i user))
+    (save-item i)
+    (save-prof i!by)))
+
+(def candelete (user i)
+  (or (admin user) (own-changeable-item user i)))
 
 (def deletelink (i user whence)
   (when (candelete user i)
@@ -995,19 +1341,19 @@
 (def permalink (story user)
   (when (cansee user story)
     (pr bar*) 
-    (link "link" (item-url story))))
+    (link "link" (item-url story!id))))
 
-(def logvote (user story)
-  (newslog user 'vote (story 'id) (list (story 'title))))
+(def logvote (ip user story)
+  (newslog ip user 'vote (story 'id) (list (story 'title))))
 
 (def text-age (a)
   (tostring
     (if (>= a 1440) (let n (trunc (/ a 1440))
-                      (pr n (plural n " day")    " ago"))
+                      (pr (plural n "day")    " ago"))
         (>= a   60) (let n (trunc (/ a 60))
-                      (pr n (plural n " hour")   " ago"))
+                      (pr (plural n "hour")   " ago"))
                     (let n (trunc a)
-                      (pr n (plural n " minute") " ago")))))
+                      (pr (plural n "minute") " ago")))))
 
 
 ; Voting
@@ -1017,60 +1363,92 @@
 ; new- thresholds won't affect rankings, though such votes still affect 
 ; scores unless not a legit-user.
 
-(= legit-threshold* 0 new-age-threshold* 0 new-karma-threshold* 0)
+(= legit-threshold* 0 new-age-threshold* 0 new-karma-threshold* 2)
 
 (def legit-user (user) 
   (or (editor user)
       (> (karma user) legit-threshold*)))
 
 (def possible-sockpuppet (user)
-  (or (uvar user ignore)
+  (or (ignored user)
       (< (uvar user weight) .5)
       (and (< (user-age user) new-age-threshold*)
            (< (karma user) new-karma-threshold*))))
 
+(= downvote-ratio-limit* .65)
+
 (= recent-votes* nil)
 
+(= votewindow* 100)
+
 ; Note: if vote-for by one user changes (s 'score) while s is being
 ; edited by another, the save after the edit will overwrite the change.
 ; Actual votes can't be lost because that field is not editable.  Not a
 ; big enough problem to drag in locking.
 
 (def vote-for (user i (o dir 'up))
-  (unless ((votes* user) i!id)
-    (atwiths (ip   (logins* user)
-              vote (list (seconds) ip user dir i!score))
-      (unless (or (and (uvar user ignore)
+  (unless (or ((votes user) i!id) 
+              (and (isnt user i!by) (~live i)))
+    (withs (ip   (logins* user)
+            vote (list (seconds) ip user dir i!score))
+      (unless (or (and (or (ignored user) (check-key user 'novote))
                        (isnt user i!by))
-                  ; prevention of karma-bombing
-                  (and (is dir 'down) 
-                       (or (and (~editor user) (just-downvoted user i!by))
-                           (uvar user nodowns)))
-                  (and (no (legit-user user))
-                       (find [is (cadr _) ip] i!votes)))
+                  (and (is dir 'down)
+                       (~editor user)
+                       (or (check-key user 'nodowns)
+                           (> (downvote-ratio user) downvote-ratio-limit*)
+                           ; prevention of karma-bombing
+                           (just-downvoted user i!by)))
+                  (and (~legit-user user)
+                       (isnt user i!by)
+                       (find [is (cadr _) ip] i!votes))
+                  (and (isnt i!type 'pollopt)
+                       (biased-voter i vote)))
         (case dir up   (++ i!score)
                   down (-- i!score))
         ; canvote protects against sockpuppet downvote of comments 
         (when (and (is dir 'up) (possible-sockpuppet user))
           (++ i!sockvotes))
-        (if (storylike i) (adjust-rank i))
-        ; get equal karma for comments
-        (unless (or (is user i!by)
-                    (and (is ip i!ip) (~editor user)))
+        (if (metastory i) (adjust-rank i))
+        (unless (or (author user i)
+                    (and (is ip i!ip) (~editor user))
+                    (is i!type 'pollopt))
           (case dir up   (++ (karma i!by)) 
                     down (-- (karma i!by)))
-          (save-prof i!by)))
+          (save-prof i!by))
+        (wipe (comment-cache* i!id)))
+      (if (admin user) (pushnew 'nokill i!keys))
       (push vote i!votes)
-      (push (cons i!id vote) recent-votes*)
       (save-item i)
+      (push (list (seconds) i!id i!by (sitename i!url) dir)
+            (uvar user votes))
       (= ((votes* user) i!id) vote)
-      (save-votes user))))
+      (save-votes user)
+      (zap [firstn votewindow* _] (uvar user votes))
+      (save-prof user)
+      (push (cons i!id vote) recent-votes*))))
+
+; redefined later
+
+(def biased-voter (i vote) nil)
+
+; ugly to use car, cadr to manipulate vote fields
+
+(def downvote-ratio (user (o sample 20))
+  (let vs (keep (fn (x)
+                  (let by ((item (car x)) 'by)
+                    (nor (is by user) (ignored by))))
+                (bestn sample (compare > car:cadr) (tablist (votes user))))
+    (if vs
+        (/ (count [is ((cadr _) 3) 'down] vs)
+           (len vs)) 
+        0)))
 
 (def just-downvoted (user victim (o n 3))
   (let prev (firstn n (recent-votes-by user))
     (and (is (len prev) n)
          (all (fn ((id sec ip voter dir score))
-                (and (is ((item id) 'by) victim) (is dir 'down)))
+                (and (author victim (item id)) (is dir 'down)))
               prev))))
 
 ; Ugly to pluck out fourth element.  Should read votes into a vote
@@ -1092,7 +1470,7 @@
   (login-page 'both "You have to be logged in to submit."
               (fn (user ip) 
                 (ensure-news-user user)
-                (newslog user 'submit-login ip)
+                (newslog ip user 'submit-login)
                 (submit-page user url title showtext text))))
 
 (def submit-page (user (o url) (o title) (o showtext) (o text "") (o msg))
@@ -1100,11 +1478,11 @@
     (pagemessage msg)
     (urform user req
             (process-story (get-user req)
-                           (striptags (arg req "u")) 
+                           (clean-url (arg req "u"))
                            (striptags (arg req "t"))
                            showtext
                            (and showtext (md-from-form (arg req "x") t))
-                           (req 'ip))
+                           req!ip)
       (tab
         (row "title"  (input "t" title 50))
         (if prefer-url*
@@ -1118,7 +1496,7 @@
         (row "" (submit))
         (spacerow 20)
         (row "" submit-instructions*)))))
-      
+
 (= submit-instructions*
    "Leave url blank to submit a question for discussion. If there is 
     no url, the text (if any) will appear at the top of the comments 
@@ -1133,17 +1511,24 @@
       (submit-page user u t)
       (submit-login-warning u t)))
 
-(= title-limit* 100
-   retry*     "Please try again."
-   toolong*   (string "Please make title < " title-limit* " characters.")
-   bothblank* "The url and text fields can't both be blank.  Please
-               either supply a url, or if you're asking a question,
-               put it in the text field.")
+(= title-limit* 80
+   retry*       "Please try again."
+   toolong*     (string "Please make title < " title-limit* " characters.")
+   bothblank*   "The url and text fields can't both be blank.  Please
+                 either supply a url, or if you're asking a question,
+                 put it in the text field."
+   toofast*     "You're submitting too fast.  Please slow down.  Thanks."
+   spammage*    "Stop spamming us.  You're wasting your time.")
+
+; Only for annoyingly high-volume spammers. For ordinary spammers it's
+; enough to ban their sites and ip addresses.
+
+(disktable big-spamsites* (+ newsdir* "big-spamsites"))
 
 (def process-story (user url title showtext text ip)
   (aif (and (~blank url) (live-story-w/url url))
        (do (vote-for user it)
-           (item-url it))
+           (item-url it!id))
        (if (no user)
             (flink [submit-login-warning url title showtext text])
            (no (and (or (blank url) (valid-url url)) 
@@ -1153,34 +1538,108 @@
             (flink [submit-page user url title showtext text toolong*])
            (and (blank url) (blank text))
             (flink [submit-page user url title showtext text bothblank*])
-           (atlet s (create-story url (scrubtitle title) text user ip)
-             (ban-test user s ip url url-kill* url-ignore*)
-             (when (uvar user ignore) (kill s))
-             (push s!id (uvar user submitted))
-             (save-prof user)
-             (vote-for user s)
+           (big-spamsites* (sitename url))
+            (flink [msgpage user spammage*])
+           (oversubmitting user ip 'story)
+            (flink [msgpage user toofast*])
+           (let s (create-story url (process-title title) text user ip)
+             (story-ban-test user s ip url)
+             (when (ignored user) (kill s 'ignored))
+             (submit-item user s)
+             (maybe-ban-ip s)
              "newest"))))
 
-(= scrubrules* '(("Breaking: " "") ("Exclusive: " "")))
+(def submit-item (user i)
+  (push i!id (uvar user submitted))
+  (save-prof user)
+  (vote-for user i))
+
+; Turn this on when spam becomes a problem.
+
+(= enforce-oversubmit* nil)
+
+; New user can't submit more than 2 stories in a 2 hour period.
+; Give overeager users the key toofast to make limit permanent.
+
+(def oversubmitting (user ip (o kind 'story))
+  (and enforce-oversubmit*
+       (or (check-key user 'toofast)
+           (ignored user)
+           (< (user-age user) new-age-threshold*)
+           (< (karma user) new-karma-threshold*))
+       (len> (recent-items [or (author user _) (is _!ip ip)] 120)
+             (if (is kind 'story)
+                 (if (ignored user) 0 1)
+                 (if (ignored user) 2 10)))))
+
+; Note that by deliberate tricks, someone could submit a story with a 
+; blank title.
+
+(diskvar scrubrules* (+ newsdir* "scrubrules"))
+
+(def process-title (s)
+  (zap upcase (s 0))
+  (multisubst scrubrules* s))
 
-; Note that by deliberate tricks, someone could thus submit a story 
-; with a blank title.
+(def live-story-w/url (url) 
+  (aand (url->story* (canonical-url url)) (check (item it) live)))
 
-(def scrubtitle (str) (multisubst scrubrules* str))
+(def parse-site (url)
+  (rev (tokens (cadr (tokens url [in _ #\/ #\?])) #\.)))
 
-(def live-story-w/url (url) 
-  (aand (url->story* url) (check it live)))
+(defmemo sitename (url)
+  (and (valid-url url)
+       (let toks (parse-site (rem #\space url))
+         (if (isa (saferead (car toks)) 'int)
+             (tostring (prall toks "" "."))
+             (let (t1 t2 t3 . rest) toks  
+               (if (or (mem t1 multi-tld-countries*) 
+                       (and t3 (mem t2 long-domains*)))
+                   (string t3 "." t2 "." t1)
+                   (string t2 "." t1)))))))
+
+; Minor bug: can have both google.at and google.co.at.  Same for jp.
+
+(= multi-tld-countries* '("uk" "jp" "au" "in" "ph" "tr" "za" "my" "nz" "br" 
+                          "mx" "th" "sg" "id" "pk" "eg" "il" "at" "pl"))
+
+(= long-domains* '("blogspot" "wordpress" "livejournal" "blogs" "typepad" 
+                   "weebly" "blog-city"
+                   ; "sampasite"  "multiply" "wetpaint" ; let's just try banning
+                   "eurekster" "blogsome" "edogo" "blog" "com"))
+
+(def create-story (url title text user ip)
+  (newslog ip user 'create url (list title))
+  (let s (inst 'item 'type 'story 'id (new-item-id) 
+                     'url url 'title title 'text text 'by user 'ip ip)
+    (save-item s)
+    (= (items* s!id) s)
+    (unless (blank url) (register-url s url))
+    (push s stories*)
+    s))
+
+
+; Bans
 
 ; Kill means stuff with this substring gets killed. Ignore is stronger,
 ; means that user will be auto-ignored.  Eventually this info should
 ; be stored on disk and not in the source code.
 
-(= url-kill*        nil
-   url-ignore*      '("internetisseriousbusiness")
-   comment-kill*    nil
-   comment-ignore*  '("http://internetisseriousbusiness"
-                      "http://www.internetisseriousbusiness")
-   ip-ban*          nil)
+(disktable banned-ips*     (+ newsdir* "banned-ips"))   ; was ips
+(disktable banned-sites*   (+ newsdir* "banned-sites")) ; was sites
+
+(diskvar  comment-kill*    (+ newsdir* "comment-kill"))
+(diskvar  comment-ignore*  (+ newsdir* "comment-ignore"))
+
+(= comment-kill* nil ip-ban-threshold* 3)
+
+(def set-ip-ban (user ip yesno (o info))
+  (= (banned-ips* ip) (and yesno (list user (seconds) info)))
+  (todisk banned-ips*))
+
+(def set-site-ban (user site ban (o info))
+  (= (banned-sites* site) (and ban (list ban user (seconds) info)))
+  (todisk banned-sites*))
 
 ; Kill submissions from banned ips, but don't auto-ignore users from
 ; them, because eventually ips will become legit again.
